#include <iostream>

int main()
{
    int n, k;
    int madjije[200000];

    std::cin >> n >> k;

    for (int i = 0; i < n; ++i) {
        std::cin >> madjije[i];
    }

    int prviIndex = 0;
    int zadnjiIndex = n - 1;
    for (int i = 1; i < k; ++i) {
        int prvi = madjije[prviIndex];
        int zadnji = madjije[prviIndex];
        int prza = prvi - zadnji;
        int zapr = zadnji - prvi;
        if (prza > zapr) {
            madjije[prvi] = prza;
            zadnjiIndex--;
        }
        else {
            madjije[zadnji] = zapr;
            prviIndex++;
        }
    }

    int max = madjije[prviIndex];
    for (int i = prviIndex; i <= prviIndex; i++) {
        int madjija = madjije[i];
        if (madjija > max) max = madjija;
    }

    std::cout << max;
}